<template>
  <q-layout view="lHh lpr lFf">
    <Menu />
    <q-separator />
    <q-banner v-show="loaded" class="text-white bg-primary">
      Noua promotie te asteapta! Foloseste codul
      <span class="text-weight-bold">{{voucher.code}}</span>
      pentru a beneficia de {{voucher.value}} {{voucher.type=="percent"?'%':'RON'}} reducere la produsele tale preferate!
    </q-banner>
    <q-page-container>
      <router-view />
    </q-page-container>
    <q-banner class="footer text-white bg-primary">
      <q-btn :to="{ name: 'Terms & Conditions' }" no-caps flat label="Terms&Conditions" />
      <q-btn :to="{ name: 'FAQ' }" no-caps flat label="FAQ" />
      <q-btn :to="{ name: 'About Us' }" no-caps flat label="About Us" />
    </q-banner>
  </q-layout>
</template>

<script>
import EssentialLink from "components/EssentialLink";
import Menu from "components/Menu.vue";
import Footer from "components/Footer.vue";
import { LocalStorage } from "quasar";

export default {
  name: "MainLayout",
  components: {
    Menu,
    Footer,
  },
  data() {
    return {
      loaded: false,
      voucher: { value: 0, type: "percent", code: "000000" },
      leftDrawerOpen: false,
    };
  },
  async mounted() {
    setTimeout(() => {
      const items = JSON.parse(this.activatedVoucherString);
      if (items.length > 0) {
        this.voucher = items[Math.floor(Math.random() * items.length)];
        this.loaded = true;
      }
    }, 1500);
    setInterval(() => {
      const items = JSON.parse(this.activatedVoucherString);
      if (items.length > 0)
        this.voucher = items[Math.floor(Math.random() * items.length)];
    }, 10000);
  },
  async beforeMount() {
    this.$store.dispatch("adminData/loadCategories");
    this.$store.dispatch("adminData/loadProducts");
    this.$store.dispatch("adminData/loadAdminPreferences");
    if (LocalStorage.getItem("loggedIn")) {
      this.$store.dispatch("adminData/loadShoppingCart");
      this.$store.dispatch("adminData/loadVouchers");
      this.$store.dispatch("adminData/loadCurrentUserProducts");
    }
  },
  computed: {
    adminPreferences() {
      return this.$store.getters["adminData/getAdminPreferences"];
    },
    activatedVoucherString() {
      const x = this.adminPreferences.find(
        (preference) => preference.name === "activatedVouchers"
      );

      if (x) return x.value;
      else return null;
    },
  },
};
</script>

<style lang="scss" scoped>
.footer {
  position: absolute;
  right: 0;
  bottom: 0;
  left: 0;
  padding: 1rem;
  background-color: $grey-5;
  text-align: center;
}
</style>
